package com.chelvc.framework.upload.support;

import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;

import com.chelvc.framework.base.util.HttpUtils;
import com.chelvc.framework.upload.UploadHandler;
import com.chelvc.framework.upload.config.StandardUploadProperties;
import lombok.NonNull;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.condition.ConditionalOnBean;
import org.springframework.stereotype.Component;

/**
 * 文件上传标准实现
 *
 * @author Woody
 * @date 2023/5/6
 */
@Slf4j
@Component
@ConditionalOnBean(StandardUploadProperties.class)
@RequiredArgsConstructor(onConstructor = @__(@Autowired))
public class StandardUploadHandler implements UploadHandler {
    private final StandardUploadProperties properties;

    /**
     * 将唯一标识转换成资源地址
     *
     * @param key 唯一标识
     * @return 资源地址
     */
    private String key2uri(String key) {
//        return String.format(
//                "https://%s.cos.%s.myqcloud.com/%s",
//                this.properties.getBucket(), this.properties.getRegion(), key
//        );
        return HttpUtils.url(this.properties.getDomain(), key);
    }

    @Override
    public String upload(@NonNull File file) {
        return null;
    }

    @Override
    public String upload(@NonNull InputStream stream, @NonNull String filename) {
        return null;
    }

    @Override
    public String upload(@NonNull InputStream stream, @NonNull String filename, long size) {
        return null;
    }

    @Override
    public String upload(@NonNull BufferedImage image) throws IOException {
        return null;
    }
}
